* LIBFIX
* Program to replace all occurrences
* of &OLD_STR with &NEW_STR
* Compile with the switch: /n
* From Dennis Scott
* Clipper-F (757)
* Mod: Roger Grant
* Recommendthatyou keep a copy of the original library. Rename all
* original libaries to the extension of .L50 befor running this program.
* The code is relased to public domain.
* Jerry Wightman
* CompuServe 71075,457 or 71545,1244
* Compile with /N switch
* Clear out all TSR the recompile takes some time!!!!!!

**************************************
FUNCTION libfix( file1, file2 )
// Use this to replace all occurrences of a series
// of characters with another series
// Note both must be the same length.
        old_str :=  "CLIPPER501"
        new_str :=  "CLIPPER520"

        nLineFlag := PROCLINE() + 1
        IF LEN(old_str) != LEN(new_str)
                IF nLineFlag > 0
                        ?
                        ? "Programmer's ERROR:  In program line  "
                        ?? LTRIM(STR( nLineFlag,10,0) )
                ENDIF
                error_msg( " Old and new strings must be the same length. ")
                ERRORLEVEL(254)
                QUIT
        ENDIF

        SETCOLOR( "W+/B","N/BG")
        CLEAR

        @ 2,0 TO 6,79
        @ 3,1 SAY PADC("program to replace all occurrences",78)
        @ 4,1 SAY PADC("  of:  " + old_str, 78)
        @ 5,1 SAY PADC("with:  " + new_str, 78)

        IF PCOUNT() > 0 ;
.AND. UPPER(LTRIM(RTRIM( file1 ))) $ "?~/?~-?~H~/H~-H~HELP~/HELP~-HELP"
?
? "  +---------------------------------------------------------------------"
? "  | This program can be used to replace all occurrences of one series   "
? "  | of characters or bytes with the contents of anothe series.          "
? "  |                                                                     "
? "  | The program is compiled to solve a problem with upgradeing THIRD    "
? "  | PARTY LIB. from Clipper 5.01 to 5.2                                 "
? "  |                                                                     "
? "  | File names also may be entered on the command line as:              "
? "  | LIBFIX  <Input file> <Output file>                                  "
? "  | Example:                                                            "
? "  |                  LIBFIX NANFOR.L50   NANFOR.LIB                     "
? "  +---------------------------------------------------------------------"
wait
ERRORLEVEL(1)
QUIT
ENDIF

IF PCOUNT() > 0 .AND. file( file1 )
        f_in := UPPER(file1)
        @ 8,1 SAY " file to convert: " + f_in
ELSE
        f_in := space(13)
        @ 8,1 SAY "Enter file to convert: " GET f_in picture  "@!"
        SET CONFIRM ON
        READ
ENDIF

f_in := TRIM(f_in)
IF LEN(f_in) == 0
        ERRORLEVEL(1)
        QUIT
ENDIF

IF .NOT. file( f_in )
        error_msg("FILE NOT FOUND: " + f_in)
        ERRORLEVEL(1)
        QUIT
ENDIF

IF PCOUNT() > 1
        f_out := UPPER(file2)
        @ 10,1 SAY "Output file name: " + f_out
ELSE
        f_out := space(13)
        @ 10,10 SAY "Enter output file name:"  GET f_out picture "@!"
        SET CONFIRM ON
        READ
ENDIF

f_out := TRIM(f_out)
IF LEN(f_out) == 0
        ERRORLEVEL(1)
        QUIT
ENDIF

IF f_in == f_out
        error_msg(  "DUPLICATE FILE NAME ERROR" )
        ERRORLEVEL(1)
        QUIT
ENDIF
IF FILE( f_out )
        DEVPOS(11,0)
        x_color := SETCOLOR("W+/R")

        ? CHR(7)
        ? " File already exists:  " + f_out
        ?
        SETCOLOR(x_color)
        ? CHR(7)
        l_kill := .F.
        n_row := row()
        @ n_row, 2 SAY "OK to overwrite? " GET l_kill picture "Y"
        SET CONFIRM OFF
        READ
        IF .NOT. l_kill
                ERRORLEVEL(1)
                QUIT
        ENDIF
        @ n_row - 2 ,0 CLEAR TO n_row+1, 79
ENDIF

fh_in := FOPEN( f_in )
IF fh_in < 0
        error_msg("UNABLE TO OPEN FILE: " + f_in)
        ERRORLEVEL(1)
        QUIT
ENDIF

fh_out := FCREATE( f_out )
IF fh_out < 0
        error_msg(  "UNABLE TO CREATE OUTPUT FILE: " + f_out)
        FCLOSE(fh_in)
        ERRORLEVEL(1)
        QUIT
ENDIF

cStr := SUBSTR(old_str,1)
cStrLen := LEN(cStr)

c1 := space(1)
FSEEK( fh_in , 0 )  // position to beginning of input file
bytes_in := 0

bytes_in := FREAD( fh_in, @cStr, cStrLen )
IF bytes_in < cStrLen
        FCLOSE( fh_in)
        FCLOSE( fh_out)
        FERASE(f_out)
   error_msg( "FILE TOO SMALL, COULD NOT CONTAIN DESIRED DATA: " + f_in)
   ERRORLEVEL(1)
        QUIT
ENDIF

bytes_out := 0
nShow := 0
DEVPOS(12,0)
?
while bytes_in > 0
        // read next xharacter and temporarly ho;d it in c1:
        bytes_in := FREAD( fh_in, @c1, 1 )
        IF bytes_in < 1
                // Write out the rest of the buffer:
                bytes_out := FWRITE( fh_out, cStr, cStrLen)
                IF bytes_out  < cStrLen
                        error_out()
                        WAIT
                ELSE
                        ?
                        ? PADC(" DONE ",80, CHR(205))
                        ?

                ENDIF
                EXIT
        ENDIF
        // Write out oldest character :
        bytes_out := FWRITE( fh_out, LEFT(cStr,1), 1)
        IF bytes_out <> 1
                FCLOSE(fh_in)
                FCLOSE(fh_out)
                error_out()
                WAIT
                ERRORLEVEL(1)
                QUIT
        ENDIF
        // Shift buffer and add the next character that was read above:
        cStr := SUBSTR( cStr, 2, cStrlen-1) + c1
        // Check for character series that needs to be subsitited:
        Check_it()

        nShow ++
        IF nShow > 63
                // Show activity only every 64th byte:
                nShow := 0
                ?? "."
                IF inkey() == 27
                   FCLOSE(fh_in)
                   FCLOSE(fh_out)
                   x_color := SETCOLOR( "W+/R")
                   ? CHR(7)
                   ? PADC("ESCAPE was pressed.  program terminated.",80)
                   ? PADC("File will be truncated(may not be complete).",80)
                   ? CHR(7)
                   SETCOLOR( x_color)
                   QUIT
                ENDIF
        ENDIF
ENDDO
FCLOSE(fh_in)
FCLOSE(fh_out)
RETURN (NIL)



FUNCTION error_out()
LOCAL x_color := SETCOLOR( "W+/R")
?
? "     Error writing output file.               "
? CHR(7)
? " File will be truncated(may not be complete). "
? CHR(7)
SETCOLOR( x_color )
RETURN (NIL)

****************************
FUNCTION error_msg()
LOCAL x_color := SETCOLOR("W+/R")
?
? CHR(7)
? SPACE(1)
?? c_msg
?? space(1)
? CHR(7)

SETCOLOR( x_color)
WAIT
RETURN (NIL)
************************

FUNCTION Check_it()
STATIC ncount := 0
IF cStr == old_str
// skipthe subtitution if TEST is defined.
#ifndef TEST
// make the substitution
        cStr := new_str
#endif
        nCount ++
        ? nCount
        ?? ":  "
        ?? old_str
        ?? " --> "
        ?? new_str
        ?? "  "
        ?
        ENDIF
        RETURN (NIL)


* EOF



